#if !defined( __DPMI16__ ) && !defined( __DPMI32__ )
#error DPMI library code must be compiled with BCC -ml -WX or BCC32 -WX
#endif

#ifdef	__DPMI32__
#pragma inline
#endif

#include	<windows.h>


// Set up generic types that work transparently across 16 and 32 bits.
//
#ifdef	__DPMI32__
#	define	BYTE2		USHORT
#	define	BYTE4		UINT

#else
#	define	UCHAR		unsigned char
#	define	ULONG		unsigned long
#	define	BYTE2		UINT
#	define	BYTE4		ULONG
#endif

#define	SELTYPE	BYTE2	// Size of selectors
#define	OFFTYPE	UINT	// Size of offsets


struct FUNC300_STRUCT
{
  BYTE4	edi,
        esi,
        ebp,
        always_0,
        ebx,
        edx,
        ecx,
        eax;

  BYTE2	flags,
        es,
        ds,
        fs,
        gs,
        ip,
        cs,
        sp,
        ss;
};


BYTE2	allocRealMem( BYTE2 *selPtr, UINT nBytes );
void	freeRealMem( BYTE2 realSel );
void  protToRealnCopy( BYTE2 destSel, BYTE2 *srcOff, UINT nBytes );
void	simulateRealModeInt( UCHAR theInt, FUNC300_STRUCT *parmsPtr );
